/* Find out the most common ancestor between two trees using a breadth
   first search.

  Copyright (C) 2004 Walter Landry
   
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#ifndef ARX_COMPUTE_ANCESTOR_HPP
#define ARX_COMPUTE_ANCESTOR_HPP

#include "boost/filesystem/operations.hpp"
#include "Parsed_Name.hpp"
#include <list>

std::list<Parsed_Name> compute_ancestor
(const Parsed_Name &main,
 const boost::filesystem::path &main_path,
 const Parsed_Name &sibling,
 const boost::filesystem::path &sibling_path);

#endif
