/* Move all of the deletes and renames to their final resting place.

  Copyright (C) 2003, 2004 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#ifndef ARX_MOVE_ORIGINAL_AWAY_HPP
#define ARX_MOVE_ORIGINAL_AWAY_HPP

#include <list>
#include "Checksums.hpp"
#include "boost/filesystem/operations.hpp"

void move_original_away(const boost::filesystem::path &root,
                        const boost::filesystem::path &source,
                        const boost::filesystem::path &destination,
                        std::list<std::pair<std::string,std::string> > &conflicts,
                        const Checksums &checksums);

void move_original_away(const boost::filesystem::path &root,
                        const boost::filesystem::path &destination,
                        std::list<std::pair<std::string,std::string> > &conflicts,
                        const Checksums &checksums);

void move_original_away(const boost::filesystem::path &root,
                        const boost::filesystem::path &source,
                        const boost::filesystem::path &destination,
                        std::list<std::pair<std::string,std::string> > &conflicts);

#endif

